//
//  SeamController.m
//  seamus
//
//  Created by Wim Lewis on 22Aug07.
//  Copyright 2007 Wim Lewis.
//  You may distribute and/or modify this code under the terms of the GNU General Public License as published by the Free Software Foundation, version 2, or (at your option) any later version.
//

#import "SeamController.h"
#import "Seamer.h"
#import "SeamyView.h"
#import "ScrunchyView.h"

@implementation SeamController

- (IBAction)dropImage:sender
{
    NSImage *i = [sender image];
    if (!i || ![i isValid]) {
        NSBeep();
        return;
    }
    
    if (seamer) {
        [seamer release];
        seamer = nil;
        [resultView setSeamer:nil];
        [scruncher setSeamer:nil];
    }
    seamer = [[Seamer alloc] initWithImage:i delegate:self];
    [resultView setSeamer:seamer];
    [seamer setEnergyFunction:[energyFunctionField stringValue]];
    
    [statusField setStringValue:@"Computing energy function..."];
    [[statusField window] display];
    
    [seamer computeEnergyFunction];
    [statusField setStringValue:@""];
}

- (IBAction)changeFunction:sender
{
    if (seamer) {
        [seamer setEnergyFunction:[energyFunctionField stringValue]];
        
        [statusField setStringValue:@"Computing energy function..."];
        [[statusField window] display];
        
        [seamer computeEnergyFunction];
        [statusField setStringValue:@""];
    }
}

- (void)setEnergyFuncImage:(NSImage *)efunc
{
    [energyWell setImage:efunc];
    [resultView setImage:efunc];
    [[resultView window] orderFront:self];
    [scruncher setImage:[inputWell image]];
    [[scruncher window] orderFront:self];
    [seamer performSelector:@selector(doComputeSeams:) withObject:self afterDelay:0.1];
}

- (IBAction)doMoreSeams:sender
{
    [statusField setStringValue:@"Computing seams..."];
    int targetCount;
    if ([sender tag] != 0)
        targetCount = 20 + seamer->seamcount;
    else
        targetCount = 0;
    do {
        [[statusField window] display];
        [seamer doComputeSeams:self];
        [statusField setStringValue:[NSString stringWithFormat:@"Seams: %d", seamer->seamcount]];
    } while (targetCount > seamer->seamcount);
}

- (void)anotherSeam;
{
    [resultView setNeedsDisplay:YES];
    [scruncher setSeamer:seamer];
}

- (IBAction)showReadme:sender;
{
    [[NSWorkspace sharedWorkspace] openFile:[[NSBundle mainBundle] pathForResource:@"README" ofType:@"html"]];
}

@end
