//
//  Seamer.h
//  seamus
//
//  Created by Wim Lewis on 22Aug07.
//  Copyright 2007 Wim Lewis.
//  You may distribute and/or modify this code under the terms of the GNU General Public License as published by the Free Software Foundation, version 2, or (at your option) any later version.
//

#import <AppKit/AppKit.h>

@class SeamController;

@interface Seamer : NSObject
{
    // The input image, and its size
    NSBitmapImageRep *baseImage;
    unsigned width, height;
    
    // The netpbm command(s) for computing the monochrome energy function graymap
    NSString *pipeline;

@public  // @public for ugly hacky access from SeamyView and ScrunchyView
    
    // The energy function graymap, and its size (this had better be the same as baseImage's size or we'll be sorry)
    uint8_t *energyFunction;
    int rows, cols;
    
    // The seam controller, which we call back with our discoveries
    SeamController *nonretained_delegate;
    
    // Seams we've found; each one is an array of column indices
    int seamcount;
    int **seams;
    
    // The upmap computed by the most recent dynamic programming run
    short **last_upmap;
}

- initWithImage:(NSImage *)i delegate:(SeamController *)c;
- (void)setEnergyFunction:(NSString *)pipepart;
- (void)computeEnergyFunction;
- (void)doComputeSeams:sender;
- (void)clearSeams;
- (short *)makeSkipList:(int)row count:(int)skipcount;

@end
